<template>
  <div class="list-item section-list-item">
    <div class="list-item-body">
      <h4>
        <router-link :to="sectionRoute">{{ section.displayName }}</router-link>
      </h4>
      <div>{{ section.description }}</div>
    </div>
    <div class="list-item-footer">
      <ul class="responsive">
        <li>
          <i class="bi bi-folder2-open"></i>
          {{ topicCountText }}
        </li>
        <li class="section-list-item__last-post">
          <i class="bi bi-clock"></i>
          <router-link :to="lastPostRoute" data-bs-toggle="tooltip" :title="lastPostTooltip">Last post</router-link>
          <span data-bs-toggle="tooltip" :title="lastPostCreatedTooltip">{{ lastPostCreatedText }}</span>
          <router-link :to="lastPostUserRoute">by {{ lastPostUserText }}</router-link>
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
import { ref, computed, onUnmounted } from 'vue'
import { useStore } from 'vuex'
import { StringHelper, useMoment } from '../../core'

export default {
  name: 'SectionListItem',
  props: {
    section: { type: Object, required: true },
  },
  setup(props) {
    const store = useStore()
    const moment = useMoment()

    const lastPostCreatedText = ref('')
    const lastPostCreatedTooltip = ref('')
    const interval = ref(undefined)

    const topicCountText = computed(() => {
      return StringHelper.noun(props.section.topicCount, 'topic', 'topics')
    })

    const sectionRoute = computed(() => {
      return props.section ? { name: 'forum-section', params: { codeName: props.section.codeName } } : null
    })

    const lastPostTooltip = computed(() => {
      return props.section.lastPost?.topic ? props.section.lastPost.topic.title : ''
    })

    const lastPostRoute = computed(() => {
      return props.section.lastPost?.topic
        ? {
            name: 'forum-topic',
            params: { alias: props.section.lastPost.topic.alias, postId: props.section.lastPostId },
            hash: `#post${props.section.lastPostId}`,
          }
        : null
    })

    const lastPostUserRoute = computed(() => {
      return props.section.lastPost?.user
        ? { name: 'identity-user-profile', params: { username: props.section.lastPost.user.username } }
        : null
    })

    const lastPostUserText = computed(() => {
      return props.section.lastPost?.user?.username || ''
    })

    const updateRelativeMomentText = () => {
      if (!props.section.lastPost) {
        lastPostCreatedText.value = ''
        lastPostCreatedTooltip.value = ''
      } else {
        const lastPostCreatedRelative = moment(props.section.lastPost.created).fromNow()
        const lastPostCreatedAbsolute = moment(props.section.lastPost.created).format('llll')

        const relativeDatetimes = store.state.core.persisted.relativeDatetimes
        lastPostCreatedText.value = relativeDatetimes ? lastPostCreatedRelative : lastPostCreatedAbsolute
        lastPostCreatedTooltip.value = relativeDatetimes ? lastPostCreatedAbsolute : lastPostCreatedRelative
      }
    }

    onUnmounted(() => {
      clearInterval(interval.value)
    })

    updateRelativeMomentText()
    interval.value = setInterval(function () {
      updateRelativeMomentText()
    }, 1000)

    return {
      lastPostCreatedText,
      lastPostCreatedTooltip,
      interval,
      topicCountText,
      sectionRoute,
      lastPostTooltip,
      lastPostRoute,
      lastPostUserRoute,
      lastPostUserText,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.section-list-item__last-post a,
.section-list-item__last-post span {
  margin-left: vars.$iconSpacing;
}
</style>
